;EasyCodeName=Module1,1
;................................................
.686 ; create 32 bit code
;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include   \masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include   \masm32\fpulib\fpu.inc
IncludeLib   \masm32\fpulib\fpu.lib
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	MyMacros.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
calculateLinearRoot Proto :DWord,:DWord
InputR10            Proto :DWord

.Data
Number0         Real10  0.0   ; used to determine if there are real roots in the
                              ; quadratic formula
Number2         Real10  2.0   ; number to use to get the denominator in the quadratic formula
Number1         Real10  1.0   ; number for comparison
Number4         Real10  4.0   ; number to get part of the square root number
Minus1          REAL10 -1.0
; 
NumberA         Real10  ?     ; the coefficient of X^2 in the quadratic equation
NumberB         Real10  ?     ; the coefficient of X in the quadratic equation
NumberC         Real10  ?     ; the constant in the quadratic equation
;------------------------------------
_RootX0         Real10 ?      ; first real root solution to the quadratic formula
_RootX1         Real10 ?      ; second real root solution to the quadratic formula
_LinearRootX    Real10 ?      ; real linear root solution to the linear equation
; ##############################################################################################

; 
.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Call Main
    inkey          ; pause the screen while waiting for user to press any key
                   ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   Input10 procedure will convert input   <<
;<<   from keyboard into real10 numbers      <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

InputR10 Proc pR10:DWord   ;Ptr Real10 the pointer to Real10 value is a DWORD value
    LOCAL r8:REAL8
    invoke crt_scanf, SADD("%lf"), ADDR r8
    mov eax, pR10
    finit
    fld r8
    fstp REAL10 PTR [eax]
    ret
InputR10 EndP
; ----------------------------------------------------------------------------------------------
Main Proc
  Local WantContinue:DWord
  ; WantContinue is a sentinel value for while loop

    Mov WantContinue, 0  ; set WantContinue = 0 to start while loop

    .While ((WantContinue >= 0) && (WantContinue < -1))
    ; while WantContinue greater than or equal to 0 And
    ; WantContinue less than -1
    
       print chr$(13, 10) ; a carriage return line feed will be outputted to the
                          ; screen
       print  chr$("Quadratic Equation : Ax^2 + Bx + C ", 13, 10, 13, 10)
       print  chr$("Enter a real number for A : ")
       Invoke InputR10, Addr NumberA
       print  chr$("Enter a real number for B : ")
       Invoke InputR10, Addr NumberB
       print  chr$("Enter a real number for C : ")
       Invoke InputR10, Addr NumberC

       Invoke  FpuComp, Addr NumberA, Offset Number0, SRC1_REAL Or SRC2_REAL
       Or Eax, Eax     ; activate zero flag
       Jz ErrorInComp   ; jump if zero
       ; ------------------------------------
       ; If bit 0 of EAX=1 => NumberA=Number0
       ; ------------------------------------
       Shr Al, 1             ; mov bit 0 to Carry Flag , NumberA = 0
       Jc linear             ; jump on Carry Flag
       ;
       Call    calculateQuadraticRoots   ; no parameters its the same
                                         ; invoke calculateQuadraticRoots

       print   chr$(13, 10)
       Jmp     ToContinue
;.........................................
ErrorInComp:
        print   chr$(13, 10)
        print chr$(" Error comparing Number A against zero! ", 13, 10, 13, 10)
        jmp     ToContinue       
;..........................................
linear:
       Invoke FpuComp, Addr NumberB, Offset Number0, SRC1_REAL Or SRC2_REAL
       Or Eax, Eax   ; activates zero flag
       Jz ZeroErrors  ; jump if zero
       ; ------------------------------------
       ; If bit 0 of EAX=1 => NumberB=Number0
       ; ------------------------------------
       Shr Al, 1        ; mov bit 0 to Carry Flag , NumberB = 0
       Jc ZeroErrors    ; jump on Carry Flag
       
        Invoke   calculateLinearRoot, Addr NumberB, Addr NumberC
        Cmp Eax, 0  ; compare eax with 0
        Jne @F     ; if not equal jump forward to @@
        ;
        print   chr$(13, 10)
        print   chr$(" Error calculating linear roots", 13, 10)
        jmp     ToContinue

       ;
@@:    print chr$(13, 10)
       print chr$("Linear Equation : Bx + C ", 13, 10)
       print chr$(13, 10)
       print chr$(" Solution for linear equation : ", 13, 10)
       print chr$("-------------------------------", 13, 10)
       print chr$(" ")
       print ext$ (NumberB, 0, 4)  ; display the X coefficient of linear equation
                                   ; to 4 decimal places
       Invoke FpuComp, Addr NumberC, Offset Number0, SRC1_REAL Or SRC2_REAL
       Shr Al, 1                  ; mov bit 0 to Carry Flag , NumberC = 0
       Jc NumberCIs0              ; jump on Carry Flag

       print chr$(" X + ")
       print ext$ (NumberC, 0, 4) ; display the constant of linear equation to
                                  ; to 4 decimal places
       Jmp Next

NumberCIs0:
	   print chr$(" X ")
Next:
	   print chr$(" = 0 ", 13, 10, 13, 10)
       print chr$(" X = ")
       print real10$ (_LinearRootX)
       print chr$(13, 10, 13, 10)
       print chr$(13, 10)
       Jmp ToContinue

ZeroErrors:
        print chr$(13, 10)
        print chr$(" Error, Numbers for A and B are zero! ", 13, 10, 13, 10)

ToContinue:
       Mov WantContinue, sval(input("Enter -1 to quit program : "))
       print chr$(13, 10)
       Invoke ClearScreen
    .EndW

  print chr$(13, 10)
  Ret
Main EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   printQuadraticFormat will output the quadratic equation entered by  <<
;<<   user to the screen                                                  <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

printQuadraticFormat Proc

                     print chr$(" ")
                     print ext$ (NumberA, 0, 4) ; display the X^2 coefficient of
                                                ; quadratic equation
                                                ; to 4 decimal places
                     print chr$(" X^2 ")
                     ;
       Invoke FpuComp, Addr NumberB, Offset Number0, SRC1_REAL Or SRC2_REAL
                     Shr Al, 1           ; mov bit 0 to Carry Flag , NumberB = 0
                     Jc NumberBIs0       ; jump on Carry Flag

                     print chr$(" + ")
                     print ext$ (NumberB, 0, 4) ; display the X coefficient of
                                                ; quadratic equation
                                                ; to 4 decimal places
                     print chr$(" X ")
                     Jmp NextC
                     ;
NumberBIs0:
NextC:
                     ;
       Invoke FpuComp, Addr NumberC, Offset Number0, SRC1_REAL Or SRC2_REAL
                     Shr Al, 1              ; mov bit 0 to Carry Flag , NumberC = 0
                     Jc NumberCIs0          ; jump on Carry Flag
                     print chr$(" + ")
                     print ext$ (NumberC, 0, 4) ; display the constant of
                                                ; quadratic equation
                                                ; to 4 decimal places
                     jmp       EndPrint 

NumberCIs0:
EndPrint:            print chr$(" = 0 ", 13, 10)
                     Ret
printQuadraticFormat EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateLinearRoot procedure will calculate the root of the linear equation  <<
;<<  B x + C = 0  =>  x = - C / B
;<<  when NumberA is equal to 0 and NumberB is not equal to 0                      <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateLinearRoot Proc  pNumB:DWord, pNumC:DWord
                    Local negativeNumC:Real10

     Lea Edx, negativeNumC  ; Edx is the pointer address of negativeNumC
     Invoke FpuChs, pNumC, Edx, SRC1_REAL
     Cmp Eax, 0      ; compare Eax with 0
     Je _rLinearRoot  ; jump if equal to 0
     ;
     Invoke FpuDiv, Edx, pNumB, Offset _LinearRootX, SRC1_REAL Or SRC2_REAL
                    ; EAX= 0 -> error
_rLinearRoot:
	 Ret
calculateLinearRoot EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateXRoots procedure will calculate the two real roots in the quadratic   <<
;<<  formula                                                                        <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
calculateXRoots Proc pNumA:DWord, pNumB:DWord, pNumC:DWord

                ; pNumA is a pointer to NumA
                ; pNumB is a pointer to NumB
                ; pNumC is a pointer to NumC

                Local NumB2:Real10
                Local Num4AC:Real10
                Local NumB2_4AC:Real10
                Local RootB2_4AC:Real10
                Local Num2A:Real10
                ; NumB2 = NumberB * NumberB
                ; Num4AC = 4 * NumberA * NumberC
                ; NumB2_4AC = (NumberB * NumberB) - (4 * NumberA * NumberC)
                ; RootB2_4AC = sqrt(NumB2_4AC)
                ; Num2A = 2 * NumberA = denominator

                Local SOLX0:Real10
                Local SOLX1:Real10
                ; SOLX0 = first solution to quadratic formula
                ; SOLX1 = second solution to quadratic formula

                Lea Ebx, NumB2  ; Ebx is a pointer address of NumB2
                invoke  FpuMul, pNumB, pNumB, ebx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax   ; activate zero flag
                Jz _rRealRoots  ; jump if zero  , error -> exit
                
                Lea Ecx, Num4AC  ; Ecx is a pointer address of Num4AC
                invoke  FpuMul, pNumA, pNumC, ecx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero  , error -> exit
                ;
                invoke  FpuMul, ecx, offset Number4, ecx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero  , error -> exit

                Lea Edx, NumB2_4AC  ; Edx is a pointer address of NumB2_4AC
                invoke  FpuSub, ebx, ecx, edx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero  , error -> exit
                ;
                ; Test if NumB2_4AC >= 0
                ; ----------------------
                invoke  FpuComp, edx, offset Number0, SRC1_REAL or SRC2_REAL
                Or Eax, Eax   ; activate zero flag
                Jz _rRealRoots ; jump if zero , error - > exit
                ;
                test    al, 00000100B
                Jz @F   ; jump if zero forward to @@ , error -> exit
                ;
                ; complex roots: NumB2_4AC < 0
                ; ----------------------------
                Mov Eax, 2  ; set Eax = 2 , Complex Roots results
                Clc  ; clear carry flag
                ret
                ;
@@:             Lea Ebx, RootB2_4AC  ; Ebx is pointer address of RootB2_4AC
                invoke  FpuSqrt, edx, ebx, SRC1_REAL 
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero , error -> exit

                Lea Ecx, SOLX0  ; Ecx is pointer address of SOLX0
                invoke  FpuSub, ebx, pNumB, ecx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero , error -> exit

                Lea Edx, SOLX1   ; Edx is pointer address of SOLX1
                invoke  FpuAdd, ebx, pNumB, edx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots ; jump if zero , error -> exit

                Lea Ebx, Num2A  ; Ebx is pointer address of Num2A
                invoke  FpuMul, pNumA, offset Number2, ebx, SRC1_REAL or SRC2_REAL
                Or Eax, Eax ; activate zero flag
                Jz _rRealRoots    ; jump if zero , error -> exit

                ; SOLX0
                invoke  FpuDiv, ecx, ebx, offset _RootX0, SRC1_REAL or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero , error -> exit

                ; SOLX1
                invoke  FpuDiv, edx, ebx, edx, SRC1_REAL or SRC2_REAL 
                Or Eax, Eax ; activate zero flag
                Jz _rRealRoots   ; jump if zero , error -> exit

                Invoke  FpuMul, Edx, Offset Minus1, Offset _RootX1, SRC1_REAL Or SRC2_REAL
                Or Eax, Eax  ; activate zero flag
                Jz _rRealRoots  ; jump if zero , error -> exit
                ;
                Mov Eax, 1   ; set Eax = 1 , Real Roots results
                Clc  ; clear carry flag
                ret
                ;
                ; EAX = 0 => Error
                ;
_rRealRoots:    

                Stc  ; set carry flag
                ret
calculateXRoots EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   calculateQuadraticRoots procedure will calculate two real roots    <<
;<<   of a quadratic equation by receiving three coefficients from       <<
;<<   user as input and display the answers                              <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateQuadraticRoots Proc

     ; Quadratic Formula:  x = (-b +/- sqrt(b^2 - 4*a*c)) / (2*a)
     ; where a, b, and c are real numbers And  a != 0

      Invoke calculateXRoots, Addr NumberA, Addr NumberB, Addr NumberC
      Jc _ExitProc ; jump on Carry Flag

      Cmp Eax, 2  ; compare Eax with 2 , complex roots results
      Je @F  ; jump if equal to 2 forward to @@

      print chr$(13, 10)
      print chr$("  Solutions for quadratic equation : ", 13, 10)
      print chr$("--------------------------------------", 13, 10)

      Invoke printQuadraticFormat

      print chr$(13, 10, 13, 10) ; two carriage return line feeds will be
                                 ; outputted to the screen
      print chr$(" X = ")
      print real10$ (_RootX0)   ; print the real number of one real root
                                ; in the quadratic formula
      print chr$(13, 10)
      print chr$("  1 ", 13, 10, 13, 10)
      print chr$(" X = ")
      print real10$ (_RootX1)   ; print the real number of another real root
                                ; in the quadratic formula
      print chr$(13, 10)
      print chr$("  2 ", 13, 10)
      print chr$(13, 10)

      Ret                       ; exit here


@@:
      print chr$(13, 10)
      print chr$(" There are no real solutions for the quadratic equation : ", 13, 10)
      print chr$("---------------------------------------------------------", 13, 10)

      ; The following statement call output format procedure of the quadratic
      ; equation

      Invoke printQuadraticFormat

      print chr$(13, 10, " This equation has complex roots! ")
      print chr$(13, 10, 13, 10) ; two carriage return line feeds to the screen
      Ret                        ; exit here
;......................................................
_ExitProc:
        print chr$(13, 10)
        print chr$(" An Error occured while calculating the roots", 13, 10)
    Ret
calculateQuadraticRoots EndP
; 
End     start
; ##############################################################################################

